\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{longinvoice}[2018/06/08]

\RequirePackage{eurosym}
\RequirePackage[table]{xcolor}
\RequirePackage{xtab}   % To define commands and environments
\RequirePackage{booktabs}
\RequirePackage{array}
\RequirePackage{numprint}
\RequirePackage{fp}
\RequirePackage{xstring}
\RequirePackage{fmtcount}
\RequirePackage{xargs}
\RequirePackage{xparse}   % To define commands and environments

\newcommand{\TAB}{&}
\newcount\numvats

\newcolumntype{Z}[1]{>{\raggedright\arraybackslash}p{\dimexpr#1\textwidth-2\tabcolsep}}
\newcolumntype{X}[1]{Z{#1}rrrr}

\newcommand{\Fee}[5]{% #1=Description, #2=VAT, #3=Value, #4=Unit, #5=Quantity, #6=Currency (ISO), #7=Currency symbol
  #1 & #3 & #4 & #5 & \FPmul\temp{#3}{#5}\FPround\temp{\temp}{2}\numprint{\temp}%
% Add to the count:
\FPadd\feesubtotal{\feesubtotal}{\temp} %  Sum the entry amount to the subtotal fee count
\global\let\feesubtotal\feesubtotal     %  Externalize the value of feesubtotal
\FPround\FeeSubtotal{\feesubtotal}{2}   %  Round subtotal to two decimal places 
\global\let\FeeSubtotal\FeeSubtotal		%  Externalize the value of FeeSubtotal for use
% Now add to the respective vat counter if the vat field is non empty and greater than 0
\IfDecimal{#2}{%						Check if the value in the vat entry is an integer
\ifcsname vat#2\endcsname%				If command vat#2 is defined then add the amount
\FPadd\temp{\temp}{\csname vat#2\endcsname}%
\FPround\temp{\temp}{2}%
\global\expandafter\let\csname vat#2\endcsname\temp%
\else%
\global\advance\numvats by 1
\global\expandafter\let\csname vat#2\endcsname\temp%
\def\passvalue{#2}%
\global\expandafter\let\csname valuevat\the\numvats\endcsname\passvalue%
\fi%
}{}%
\\}
%------------------------- Code for foreign expenses --------------------------------
\gdef\expensesubtotal{0}				% Defines the subtotal value of expenses to 0
\newcommand{\ForeignExpense}[5]{% #1=Description, #2=value, #3=Exchange rate, #4=Currency (ISO), #5=Basevalue
  #1 & #2 & #4 & \ifnum1=#3\relax\else#3\fi & \FPmul\temp{#2}{#3}\FPround\temp{\temp}{2}\numprint{\temp}%
% Add to the count:
\FPadd\expensesubtotal{\expensesubtotal}{\temp}	% Sum the entry amount to the subtotal expense count
\FPround\ExpenseSubtotal{\expensesubtotal}{2}	% Round subtotal to two decimal places (FeeSubtotal)
\global\let\ExpenseSubtotal\ExpenseSubtotal		% Externalize the value of FeeSubtotal
\global\let\expensesubtotal\expensesubtotal		% Externalize the value of feesubtotal
\\}
%------------------------- Code for simply expenses ----------------------------------
\newcommand{\Expense}[2]{%
\ForeignExpense{#1}{#2}{1}{}{}
}

% An environment for regular invoices
\NewDocumentEnvironment{invoice}{O{\euro} O{0.4}}{%
\gdef\feesubtotal{0}				    % Defines the subtotal value of fees to 0
\gdef\vatsubtotal{0}				    % To keep the count of VATs amount
\gdef\expensesubtotal{0}
\gdef\Expensesubtotal{0}
\gdef\FeeSubtotal{0}
%\gdef\expensesubtotal{0}
\global\numvats=0
\newcommand{\basecurrencysymbol}{#1}
\rowcolors{2}{invoicebackground!05}{white}
\tablefirsthead{
\toprule\rowcolor{white}
\LabelActivity & \LabelRate & \LabelUnit & \LabelCount & \LabelAmount (\basecurrencysymbol)\\
\midrule
}
%\IfDecimal{#2}{
%\FPadd\changecol{0}{#2}
%\let\colwidth\changecol
%}{}%
\begin{xtabular}{X{#2}}
\tablehead{
\rowcolor{invoicesubtotal}\LabelSubtotalFees &&&&  \FPadd\total{\FeeSubtotal}{\ExpenseSubtotal}\FPround\total{\total}{2}\total \\\toprule
\rowcolor{white} \LabelActivity & \LabelRate & \LabelUnit & \LabelCount & \LabelAmount (\basecurrencysymbol) \\\midrule
}
\tabletail{\midrule\rowcolor{invoicesubtotal} \LabelSubtotal &&&& \multicolumn{1}{r}{\FPadd\total{\FeeSubtotal}{\ExpenseSubtotal}\FPround\total{\total}{2}\total}\\}}{
\rowcolor{black}
\rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}{\color{white}\bfseries \LabelSubtotalExpenses} &&&& %
  \rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}{\bfseries\color{white}\numprint{\ExpenseSubtotal}} \tablehead{}\tabletail{}\\
  \LabelTotalFees &&&& \numprint{\FeeSubtotal} \\
%------ Insert the VAT values --------
\newcount\loopcounter%		Create a counter for the loop					
\loopcounter=0
\whiledo{\the\numvats>\the\loopcounter}{% While the num of VAT's is greater 
\global\advance\loopcounter by 1%
\newcommand{\passvalue}{\csname valuevat\the\loopcounter\endcsname}
\FPadd\newtemp{0}{\csname vat\passvalue\endcsname}%
\global\let\newtemp\newtemp
\LabelVAT\ (\passvalue\% $\times$ \csname vat\passvalue\endcsname) \TAB\TAB\TAB\TAB \FPmul\temp{\csname valuevat\the\loopcounter\endcsname}{\newtemp}\FPdiv\temp{\temp}{100}\FPround\temp\temp2\temp\FPadd\vatsubtotal{\temp}{\vatsubtotal}\global\let\vatsubtotal\vatsubtotal\\%
}%
{}%
  \LabelTotalExpenses &&&& \numprint{\ExpenseSubtotal} \\
\rowcolor{black}
\rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}{\color{white}\bfseries TOTAL} &&&& %
  \rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}{\color{white}\bfseries \FPadd\total{\FeeSubtotal}{\ExpenseSubtotal}\FPadd\total{\total}{\vatsubtotal}\FPround\total{\total}{2}\numprint{\total}}\\
\end{xtabular}
}
%---------------------- Define the feeinvoice environment -------------------------------
\NewDocumentEnvironment{feeinvoice}{O{\euro} O{0.4}}{%
\global\gdef\feesubtotal{0}				    % Defines the subtotal value of fees to 0
\global\gdef\vatsubtotal{0}				    % To keep the count of VATs amount
\global\gdef\expensesubtotal{0}
\global\numvats=0
\newcommand{\basecurrencysymbol}{#1}
\rowcolors{2}{invoicebackground!05}{white}
\tablefirsthead{
\toprule\rowcolor{white}
\LabelActivity & \LabelRate & \LabelUnit & \LabelCount & \LabelAmount (\basecurrencysymbol)\\
\midrule
}
%\IfDecimal{#2}{
%\FPadd\changecol{0}{#2}
%\let\colwidth\changecol
%}{}%
\begin{xtabular}{X{#2}}
\tablehead{
\rowcolor{invoicesubtotal}\LabelSubtotalFees &&&&  \FPadd\total{\FeeSubtotal}{\ExpenseSubtotal}\FPround\total{\total}{2}\total \\\toprule
\rowcolor{white} \LabelActivity & \LabelRate & \LabelUnit & \LabelCount & \LabelAmount (\basecurrencysymbol) \\\midrule
}
\tabletail{\midrule\rowcolor{invoicesubtotal} \LabelSubtotal &&&& \multicolumn{1}{r}{\FPadd\total{\FeeSubtotal}{\ExpenseSubtotal}\FPround\total{\total}{2}\total}\\}}{
\rowcolor{black}\tablehead{}\tabletail{}%
\rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}\textcolor{white}{\bfseries \LabelTotalFees} &&&& \rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}\textcolor{white}{\bfseries \FeeSubtotal} \\
%------ Insert the VAT values --------
\newcount\loopcounter%		Create a counter for the loop					
\loopcounter=0
\whiledo{\the\numvats>\the\loopcounter}{% While the num of VAT's is greater 
\global\advance\loopcounter by 1%
\newcommand{\passvalue}{\csname valuevat\the\loopcounter\endcsname}
\FPadd\newtemp{0}{\csname vat\passvalue\endcsname}%
\global\let\newtemp\newtemp
\LabelVAT (\passvalue\% $\times$ \csname vat\passvalue\endcsname) \TAB\TAB\TAB\TAB \FPmul\temp{\csname valuevat\the\loopcounter\endcsname}{\newtemp}\FPdiv\temp{\temp}{100}\FPround\temp\temp2\temp\FPadd\vatsubtotal{\temp}{\vatsubtotal}\global\let\vatsubtotal\vatsubtotal\\%
}%
{}%
\cellcolor{black}
\rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}{\color{white}\bfseries \LabelTOTAL} &\cellcolor{black}&\cellcolor{black}&\cellcolor{black}&\cellcolor{black} %
\rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}{\color{white}\bfseries \FPadd\total{\FeeSubtotal}{\vatsubtotal}\FPround\total{\total}{2}\total}\\
\end{xtabular}
}
%---------------------- Define the expenseinvoice environment -------------------------------
\NewDocumentEnvironment{expenseinvoice}{O{\euro} O{0.4}}{%
\gdef\feesubtotal{0}				    % Defines the subtotal value of fees to 0
\gdef\vatsubtotal{0}				    % To keep the count of VATs amount
\gdef\expensesubtotal{0}
\gdef\Expensesubtotal{0}
\gdef\FeeSubtotal{0}
%\gdef\expensesubtotal{0}
\global\numvats=0
\newcommand{\basecurrencysymbol}{#1}
\rowcolors{2}{invoicebackground!05}{white}
\tablefirsthead{
\toprule\rowcolor{white} \LabelExpenses &\centering \LabelCost &\centering \LabelCurrency &\centering \LabelFactor & \LabelAmount (\basecurrencysymbol)\\\midrule
}
%\IfDecimal{#2}{
%\FPadd\changecol{0}{#2}
%\let\colwidth\changecol
%}{}%
\begin{xtabular}{X{#2}}
\tablehead{
\rowcolor{invoicesubtotal}\LabelSubtotal &&&& \FPadd\total{\FeeSubtotal}{\ExpenseSubtotal}\FPround\total{\total}{2}\total\\\toprule
\rowcolor{white} \LabelExpense & \LabelCost & \LabelCurrency & \LabelFactor & \LabelAmount (\basecurrencysymbol)\\\midrule
}
\tabletail{\midrule\rowcolor{invoicesubtotal} \LabelSubtotal &&&& \multicolumn{1}{r}{\FPadd\total{\FeeSubtotal}{\ExpenseSubtotal}\FPround\total{\total}{2}\total}\\}%
}{
%\rowcolor{black}
%\rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}{\color{white}\bfseries TOTAL EXPENSES} &&&& %
%\rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}{\bfseries\color{white}\ExpenseSubtotal} \tablehead{}\tabletail{}\\
\rowcolor{black}
\rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}{\color{white}\bfseries \LabelTOTAL} &&&& %
\rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}{\color{white}\bfseries \FPadd\total{\FeeSubtotal}{\ExpenseSubtotal}\FPadd\total{\total}{\vatsubtotal}\FPround\total{\total}{2}\total}\\
\end{xtabular}
}
%----------------------- A command to insert expenses -------------------------------
\newcommand{\insertexpenses}{%
\rowcolor{black}
\rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt}{\color{white}\bfseries \LabelSubtotalFees} &&&&\rule{0pt}{0.5cm}\rule[-0.3cm]{0pt}{0pt} 
{\color{white}\bfseries \numprint{\FeeSubtotal}} \\
\rowcolor{white} \LabelExpense &\centering \LabelCost &\centering \LabelCurrency &\centering \LabelFactor & \LabelAmount (\basecurrencysymbol)\\\midrule
\tablehead{
  \rowcolor{invoicesubtotal}\LabelSubtotalContinuation  &&&& \FPadd\total{\FeeSubtotal}{\ExpenseSubtotal}\FPround\total{\total}{2}\numprint{\total}\\\toprule
\rowcolor{white} \LabelExpense & \LabelCost & \LabelCurrency & \LabelFactor & \LabelAmount (\basecurrencysymbol)\\\midrule
}
\tabletail{\midrule\rowcolor{invoicesubtotal} \LabelSubtotalToBeContinued &&&& \multicolumn{1}{r}{\FPadd\total{\FeeSubtotal}{\ExpenseSubtotal}\FPround\total{\total}{2}\numprint{\total}}\\}%
} 
%-------------------------------------------------------------------------------------
% As the footer is given by tikz we can use an empty headings style
\pagestyle{empty}
\xentrystretch{0}
\setlength{\aboverulesep}{0pt}
\setlength{\belowrulesep}{0pt}
\def\arraystretch{1.5}%

\definecolor{invoicebackground}{HTML}{000080}
\definecolor{invoicesubtotal}{HTML}{DCDCDC}
\endinput
